﻿using Microsoft.OpenApi.Models;
using NetworkResurrector.Application.Commands;
using Swashbuckle.AspNetCore.SwaggerGen;
using System.Linq;

namespace NetworkResurrector.Api.Swagger
{
    public class DtoSchemaFilter : ISchemaFilter
    {
        public void Apply(OpenApiSchema schema, SchemaFilterContext context)
        {
            var targetType = context.Type;
            while (targetType != null)
            {
                if (typeof(ICommand).IsAssignableFrom(targetType))
                {
                    foreach (var property in schema.Properties.ToList())
                    {
                        property.Value.ReadOnly = false;

                        switch (property.Key)
                        {
                            case "metadata":
                                schema.Properties.Remove(property.Key);
                                break;
                            default:
                                break;
                        }
                    }
                }

                targetType = targetType.DeclaringType;
            }
        }
    }
}
